Syncfusion AI Assistant

How can I help you?

Add remove panels in EJ2 JavaScript Dashboard Layout control

5 Mar 202616 minutes to read

In real-time cases, the data being presented within the dashboard need to be updated frequently which includes adding or removing the data dynamically within the dashboard. This can be achieved by using the addPanel and removePanel public methods of the control.

Add or remove panels dynamically

Panels can be added dynamically using the addPanel public method by passing the panels property as parameter. Panels can be removed dynamically by using the removePanel public method by passing the panel id value as the parameter.

It is also possible to remove all the panels in a Dashboard Layout by calling the removeAll method.

   dashboard.removeAll();

The following sample demonstrates how to add and remove panels dynamically in the Dashboard Layout control. In the sample, panels can be added in any desired position of required size by selecting them in the numeric boxes and clicking add button and remove them by selecting the id of the panel.

// initialize Dashboard Layout control
var dashboard = new ej.layouts.DashboardLayout({
    cellSpacing: [10, 10],
    columns: 5,
    panels: [{ 'id': 'Panel0', 'sizeX': 1, 'sizeY': 1, 'row': 0, 'col': 0, content: '<div class="content">0</div>' },
    { 'id': 'Panel1', 'sizeX': 3, 'sizeY': 2, 'row': 0, 'col': 1, content: '<div class="content">1</div>' },
    { 'id': 'Panel2', 'sizeX': 1, 'sizeY': 3, 'row': 0, 'col': 4, content: '<div class="content">2</div>' },
    { 'id': 'Panel3', 'sizeX': 1, 'sizeY': 1, 'row': 1, 'col': 0, content: '<div class="content">3</div>' },
    { 'id': 'Panel4', 'sizeX': 2, 'sizeY': 1, 'row': 2, 'col': 0, content: '<div class="content">4</div>' },
    { 'id': 'Panel5', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 2, content: '<div class="content">5</div>' },
    { 'id': 'Panel6', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 3, content: '<div class="content">6</div>' }
    ]
});
// render initialized Dashboard Layout
dashboard.appendTo('#dashboard_layout');

var count = 7;
var data = ["Panel0", "Panel1", "Panel2", "Panel3", "Panel4", "Panel5", "Panel6"];
var sizeX = new ej.inputs.NumericTextBox({
    placeholder: 'Ex: 1',
    floatLabelType: 'Never',
    value: 1,
    min: 1,
    max: 5
});

sizeX.appendTo('#sizex');

var idValue = new ej.dropdowns.DropDownList({
    dataSource: data
});
idValue.appendTo("#value");

var sizeY = new ej.inputs.NumericTextBox({
    //set the data to dataSource property
    placeholder: 'Ex: 1',
    floatLabelType: 'Never',
    value: 1,
    min: 1,
    max: 5
});

sizeY.appendTo('#sizey');

var row = new ej.inputs.NumericTextBox({
    //set the data to dataSource property
    placeholder: 'Ex: 1',
    floatLabelType: 'Never',
    value: 0,
    min: 0,
    max: 5
});

row.appendTo('#row');

var column = new ej.inputs.NumericTextBox({
    //set the data to dataSource property
    placeholder: 'Ex: 1',
    floatLabelType: 'Never',
    value: 0,
    min: 0,
    max: 4
});

column.appendTo('#column');

document.getElementById('add').onclick = function () {
    var panel = {
        id: "Panel" + count.toString(),
        sizeX: sizeX.value,
        sizeY: sizeY.value,
        row: row.value,
        col: column.value,
        content: "<div class='content'>" + count + "</div>"
    }
    dashboard.addPanel(panel);
    count = count + 1;
    (idValue.dataSource).push(panel.id);
    idValue.refresh();
};

document.getElementById('remove').onclick = function () {
    dashboard.removePanel(idValue.value.toString());
    (idValue.dataSource).splice((idValue.dataSource).indexOf(idValue.value.toString()), 1);
    idValue.refresh();
    idValue.value = null;
}
<!DOCTYPE html>
<html lang="en">
<head>
    <title>Essential JS 2 Dashboard Layout </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Dashboard Layout Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-layouts/styles/bootstrap5.3.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div class="inline" id="control">
            <div id="dashboard_layout"></div>
        </div>
        <div class="inline" id="properties">
            <table>
                <tbody>
                    <tr>
                        <td>SizeX</td>
                        <td> <input id="sizex"></td>
                    </tr>
                    <tr>
                        <td>SizeX</td>
                        <td> <input id="sizey"></td>
                    </tr>
                    <tr>
                        <td>Row</td>
                        <td> <input id="row"></td>
                    </tr>
                    <tr>
                        <td>Column</td>
                        <td> <input id="column"></td>
                    </tr>
                    <tr>
                        <td> </td>
                        <td>
                            <button id="add" class="e-btn e-flat e-outline">Add</button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <table>
                <tbody>
                    <tr>
                        <td>Id</td>
                        <td> <input id="value"></td>
                    </tr>
                    <tr>
                        <td> </td>
                        <td>
                            <button id="remove" class="e-btn e-flat e-danger">Remove</button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #container {
            margin: 0 auto;
            width: 800px;
        }

        #dashboard_layout .e-panel .e-panel-container .content {
            vertical-align: middle;
            font-weight: 500;
            font-size: 20px;
            text-align: center;
            line-height: 45px;
        }

        td {
            padding: 5px;
        }

        div#properties {
            width: 205px;
            margin-left: 15px;
            border: 1px solid black;
            padding: 15px;
            position: absolute;
        }

        .inline {
            display: inline-block;
        }

        div#control {
            width: 500px;
        }

        #resize {
            margin-left: 40%;
        }

        #dashboard_layout .e-panel {
            transition: none !important;
        }
    </style>
</body>

</html>

Refer to the JavaScript Dashboard Layout feature tour page for its groundbreaking feature representations. Also explore our JavaScript Dashboard Layout example to knows how to present and manipulate data.

Adding and Removing Panels in Angular Dashboard Layout Component

4 Mar 202613 minutes to read

In real-time scenarios, the data presented within the dashboard often needs to be updated frequently, which includes dynamically adding or removing data within the dashboard. This can be easily achieved by using the addPanel and removePanel public methods of the component.

Adding and Removing Panels Dynamically

Adding Panels

Panels can be added dynamically using the addPanel public method by passing the panels property as parameter.

Removing Panels

Panels can be removed dynamically using theremovePanel public method by passing the panel id value as a parameter.

Removing All Panels

It is also possible to remove all the panels in a Dashboard Layout by calling the removeAll method.

dashboard.removeAll();

The following sample demonstrates how to add and remove panels dynamically in the Dashboard Layout component. Panels can be added at any desired position with specified dimensions by configuring values in the numeric inputs and clicking the add button. Panels can be removed individually by selecting their ID.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DashboardLayoutModule } from '@syncfusion/ej2-angular-layouts'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { NumericTextBoxModule } from '@syncfusion/ej2-angular-inputs'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { ButtonComponent } from '@syncfusion/ej2-angular-buttons';
import { NumericTextBoxComponent } from '@syncfusion/ej2-angular-inputs';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';
import { DashboardLayoutComponent } from '@syncfusion/ej2-angular-layouts';

@Component({
    imports: [DashboardLayoutModule, ButtonModule, NumericTextBoxModule, DropDownListModule],
    standalone: true,
    selector: 'app-root',
    template: `
        <div class="control-section">
        <div class="inline" id="control">
            <ejs-dashboardlayout id='defaultLayout' #defaultLayout [columns]='columns' [cellSpacing]='cellSpacing'
                [panels]='panels'>
            </ejs-dashboardlayout>
        </div>
        <div class="inline" id="properties">
            <table>
                <tr>
                    <td>SizeX</td>
                    <td>
                        <ejs-numerictextbox id="sizex" #sizex placeholder="Ex: 1" floatLabelType="Never" value= 1 min=1 max=5></ejs-numerictextbox>
                    </td>
                </tr>
                <tr>
                    <td>SizeY</td>
                    <td>
                        <ejs-numerictextbox id="sizey" #sizey placeholder="Ex: 1" floatLabelType="Never" value= 1 min=1 max=5></ejs-numerictextbox>
                    </td>
                </tr>
                <tr>
                    <td>Row</td>
                    <td>
                        <ejs-numerictextbox id="row" #row placeholder="Ex: 1" floatLabelType="Never" value=0 min=0 max=5></ejs-numerictextbox>
                    </td>
                </tr>
                <tr>
                    <td>Column</td>
                    <td>
                        <ejs-numerictextbox id="column" #column placeholder="Ex: 1" floatLabelType="Never" value=0 min=0 max=4></ejs-numerictextbox>
                    </td>
                </tr>
                <tr>
                    <td> </td>
                    <td>
                        <button ejs-button id="add" #add cssClass="e-btn e-flat" (click)="addClick()">Add</button>
                    </td>
                </tr>
            </table>
            <table>
                <tr>
                    <td>Id</td>
                    <td> <ejs-dropdownlist id='dropdown' #dropdown [dataSource]='data' placeholder='Select a id value'
                        ></ejs-dropdownlist></td>
                </tr>
                <tr>
                    <td> </td>
                    <td>
                        <button ejs-button id="remove" cssClass="e-btn e-flat e-danger" (click)="removeClick()">Remove</button>
                    </td>
                </tr>
            </table>
            
        </div>
    </div>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild('defaultLayout') dashboard?: DashboardLayoutComponent;
    @ViewChild('sizex') sizeX?: NumericTextBoxComponent;
    @ViewChild('sizey') sizeY?: NumericTextBoxComponent;
    @ViewChild('row') row?: NumericTextBoxComponent;
    @ViewChild('column') column?: NumericTextBoxComponent;
    @ViewChild('add') addBtn?: ButtonComponent;
    @ViewChild('dropdown') dropDownListObject?: DropDownListComponent;

    public data: string[] = ['Panel0', 'Panel1', 'Panel2', 'Panel3', 'Panel4', 'Panel5', 'Panel6'];
    public cellSpacing: number[] = [20, 20];
    public columns: number = 5;
    public count: number = 7;
    public panel?: any;
    public panels: any = [{ 'id': 'Panel0', 'sizeX': 1, 'sizeY': 1, 'row': 0, 'col': 0, content: '<div class="content">0</div>' },
    { 'id': 'Panel1', 'sizeX': 3, 'sizeY': 2, 'row': 0, 'col': 1, content: '<div class="content">1</div>' },
    { 'id': 'Panel2', 'sizeX': 1, 'sizeY': 3, 'row': 0, 'col': 4, content: '<div class="content">2</div>' },
    { 'id': 'Panel3', 'sizeX': 1, 'sizeY': 1, 'row': 1, 'col': 0, content: '<div class="content">3</div>' },
    { 'id': 'Panel4', 'sizeX': 2, 'sizeY': 1, 'row': 2, 'col': 0, content: '<div class="content">4</div>' },
    { 'id': 'Panel5', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 2, content: '<div class="content">5</div>' },
    { 'id': 'Panel6', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 3, content: '<div class="content">6</div>' }
    ];
    addClick() {
        this.panel = {
            id: 'Panel' + this.count.toString(),
            sizeX: (this.sizeX as any).value,
            sizeY: (this.sizeY as any).value,
            row: (this.row as any).value,
            col: (this.column as any).value,
            content: "<div class='content'>" + this.count + '</div>',
        };
        this.dashboard?.addPanel(this.panel);
        this.count = this.count + 1;
        (this.dropDownListObject as any).dataSource.push(this.panel.id);
        (this.dropDownListObject as any)?.refresh();
    }
    removeClick() {
        this.dashboard?.removePanel((this.dropDownListObject as any).value);
        (this.dropDownListObject as any).dataSource.splice(
            (this.dropDownListObject as any).dataSource.indexOf(
                (this.dropDownListObject as any).value
            ),
            1
        );
        (this.dropDownListObject as any)?.refresh();
        (this.dropDownListObject as any).value = null as any;
    }
}
@import "node_modules/@syncfusion/ej2-base/styles/material3.css";
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-layouts/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-dropdowns/styles/material3.css';

#container {
    margin: 0 auto;
    width: 800px;
}

#defaultLayout .e-panel .e-panel-container .content {
    vertical-align: middle;
    font-weight: 500;
    font-size: 20px;
    text-align: center;
    line-height: 45px;
}

td {
    padding: 5px;
}

div#properties {
    width: 205px;
    margin-left: 15px;
    border: 1px solid black;
    padding: 15px;
    position: absolute;
}

.inline {
    display: inline-block;
}

div#control {
    width: 500px;
}

#resize {
    margin-left: 40%;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Refer to the Angular Dashboard Layout feature tour page for its groundbreaking feature representations. Also explore the Angular Dashboard Layout example to learn how to present and manipulate data.

Adding and Removing Panels in React Dashboard Layout Component

5 Mar 202624 minutes to read

Dashboard applications frequently require updating displayed data, including dynamically dynamically adding or removing widgets for scenarios such as user customization, real-time data monitoring, or role-based content display. The Dashboard Layout component supports these scenarios through the addPanel and removePanel public methods of the component.

Adding and Removing Panels Dynamically

Adding Panels

Panels can be added dynamically using the addPanel public method by passing the panels property as parameter.

Removing Panels

Panels can be removed dynamically using theremovePanel public method by passing the panel id value as a parameter.

Removing All Panels

It is also possible to remove all the panels in a Dashboard Layout by calling the removeAll method.

dashboard.removeAll();

The following sample demonstrates how to add and remove panels dynamically in the Dashboard Layout component. Panels can be added at any desired position with specified dimensions by entering values in the numeric inputs and clicking the add button. Panels can be removed by selecting their ID from the dropdown.

import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { DashboardLayoutComponent } from '@syncfusion/ej2-react-layouts';
import * as React from 'react';
function App() {
    let count = 7;
    let cellSpacing = [10, 10];
    let resize = ['e-south-east', 'e-east', 'e-west', 'e-north', 'e-south'];
    let panels = [
        { 'id': 'Panel0', 'sizeX': 1, 'sizeY': 1, 'row': 0, 'col': 0, content: '<div class="content">0</div>' },
        { 'id': 'Panel1', 'sizeX': 3, 'sizeY': 2, 'row': 0, 'col': 1, content: '<div class="content">1</div>' },
        { 'id': 'Panel2', 'sizeX': 1, 'sizeY': 3, 'row': 0, 'col': 4, content: '<div class="content">2</div>' },
        { 'id': 'Panel3', 'sizeX': 1, 'sizeY': 1, 'row': 1, 'col': 0, content: '<div class="content">3</div>' },
        { 'id': 'Panel4', 'sizeX': 2, 'sizeY': 1, 'row': 2, 'col': 0, content: '<div class="content">4</div>' },
        { 'id': 'Panel5', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 2, content: '<div class="content">5</div>' },
        { 'id': 'Panel6', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 3, content: '<div class="content">6</div>' }
    ];
    let data = ["Panel0", "Panel1", "Panel2", "Panel3", "Panel4", "Panel5", "Panel6"];
    let dashboardObj;
    let sizeXObj;
    let sizeYObj;
    let rowObj;
    let colsObj;
    let paneObj;
    // Adding new panels for DashboardLayout
    function onAdd(args) {
        //let proxy = this;
        let panel = [{
                'id': count.toString() + '_layout', 'sizeX': sizeXObj.value, 'sizeY': sizeYObj.value, 'row': rowObj.value, 'col': colsObj.value,
                content: '<div class="content">' + count.toString() + '</div>'
            }];
        dashboardObj.addPanel(panel[0]);
        count = count + 1;
    }
    // Removeing selected panels for DashboardLayout
    function onRemove(args) {
        dashboardObj.removePanel(paneObj.value.toString());
    }
    return (<div id='container'>
        <div className="inline" id="control">
            <DashboardLayoutComponent id='dashboard_layout' ref={s => (dashboardObj = s)} cellSpacing={cellSpacing} panels={panels} allowResizing={true} columns={5} resizableHandles={resize}/>
        </div>
        <div className="inline" id="properties">
            <table>
                <tbody>
                    <tr>
                        <td>SizeX</td>
                        <td> <NumericTextBoxComponent ref={s => (sizeXObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={1} min={1} max={5} floatLabelType="Never" id="sizeX"/></td>
                    </tr>
                    <tr>
                        <td>SizeY</td>
                        <td> <NumericTextBoxComponent ref={s => (sizeYObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={1} min={1} max={5} floatLabelType="Never" id="sizeY"/></td>
                    </tr>
                    <tr>
                        <td>Row</td>
                        <td> <NumericTextBoxComponent ref={s => (rowObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={0} min={0} max={5} floatLabelType="Never" id="row"/></td>
                    </tr>
                    <tr>
                        <td>Column</td>
                        <td> <NumericTextBoxComponent ref={s => (colsObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={0} min={0} max={4} floatLabelType="Never" id="column"/></td>
                    </tr>
                    <tr>
                        <td />
                        <td>
                            <button onClick={onAdd}>Add Panel</button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <table>
                <tbody>
                    <tr>
                        <td>Id</td>
                        <td> <DropDownListComponent ref={s => (paneObj = s)} className="col-sm-4" placeholder={"panel id"} dataSource={data} floatLabelType="Never" id="panel_id"/></td>
                    </tr>
                    <tr>
                        <td />
                        <td>
                            <button onClick={onRemove}>Remove Panel</button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>);
}
export default App;
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { DashboardLayoutComponent } from '@syncfusion/ej2-react-layouts';
import * as React from 'react';
function App() {
    let count = 7;
    let cellSpacing = [10, 10];
    let resize = ['e-south-east', 'e-east', 'e-west', 'e-north', 'e-south'];
    let panels = [
        { 'id': 'Panel0', 'sizeX': 1, 'sizeY': 1, 'row': 0, 'col': 0, content: '<div class="content">0</div>' },
        { 'id': 'Panel1', 'sizeX': 3, 'sizeY': 2, 'row': 0, 'col': 1, content: '<div class="content">1</div>' },
        { 'id': 'Panel2', 'sizeX': 1, 'sizeY': 3, 'row': 0, 'col': 4, content: '<div class="content">2</div>' },
        { 'id': 'Panel3', 'sizeX': 1, 'sizeY': 1, 'row': 1, 'col': 0, content: '<div class="content">3</div>' },
        { 'id': 'Panel4', 'sizeX': 2, 'sizeY': 1, 'row': 2, 'col': 0, content: '<div class="content">4</div>' },
        { 'id': 'Panel5', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 2, content: '<div class="content">5</div>' },
        { 'id': 'Panel6', 'sizeX': 1, 'sizeY': 1, 'row': 2, 'col': 3, content: '<div class="content">6</div>' }
    ];
    let data = ["Panel0", "Panel1", "Panel2", "Panel3", "Panel4", "Panel5", "Panel6"];
    let dashboardObj:DashboardLayoutComponent;
    let sizeXObj:NumericTextBoxComponent;
    let sizeYObj:NumericTextBoxComponent;
    let rowObj:NumericTextBoxComponent;
    let colsObj:NumericTextBoxComponent;
    let paneObj:DropDownListComponent;
    // Adding new panels for DashboardLayout
    function onAdd() {
        //let proxy = this;
        let panel = [{
                'id': count.toString() + '_layout', 'sizeX': sizeXObj.value, 'sizeY': sizeYObj.value, 'row': rowObj.value, 'col': colsObj.value,
                content: '<div class="content">' + count.toString() + '</div>'
            }];
        (dashboardObj as any).addPanel(panel[0]);
        count = count + 1;
    }
    // Removeing selected panels for DashboardLayout
    function onRemove() {
        if (paneObj.value) {
            (dashboardObj as any).removePanel(paneObj.value.toString());
        }
    }
    return (<div id='container'>
        <div className="inline" id="control">
            <DashboardLayoutComponent id='dashboard_layout' ref={s => (dashboardObj = s)} cellSpacing={cellSpacing} panels={panels} allowResizing={true} columns={5} resizableHandles={resize}/>
        </div>
        <div className="inline" id="properties">
            <table>
                <tbody>
                    <tr>
                        <td>SizeX</td>
                        <td> <NumericTextBoxComponent ref={s => (sizeXObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={1} min={1} max={5} floatLabelType="Never" id="sizeX"/></td>
                    </tr>
                    <tr>
                        <td>SizeY</td>
                        <td> <NumericTextBoxComponent ref={s => (sizeYObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={1} min={1} max={5} floatLabelType="Never" id="sizeY"/></td>
                    </tr>
                    <tr>
                        <td>Row</td>
                        <td> <NumericTextBoxComponent ref={s => (rowObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={0} min={0} max={5} floatLabelType="Never" id="row"/></td>
                    </tr>
                    <tr>
                        <td>Column</td>
                        <td> <NumericTextBoxComponent ref={s => (colsObj = s)} className="col-sm-4" placeholder={"Ex: 10"} value={0} min={0} max={4} floatLabelType="Never" id="column"/></td>
                    </tr>
                    <tr>
                        <td />
                        <td>
                            <button onClick={onAdd}>Add Panel</button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <table>
                <tbody>
                    <tr>
                        <td>Id</td>
                        <td> <DropDownListComponent ref={s => (paneObj = s)} className="col-sm-4" placeholder={"panel id"} dataSource={data} floatLabelType="Never" id="panel_id"/></td>
                    </tr>
                    <tr>
                        <td />
                        <td>
                            <button onClick={onRemove}>Remove Panel</button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>);
}
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App  from './App';

ReactDOM.render(<App />, document.getElementById('root'));
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-dropdowns/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-inputs/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-buttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-layouts/styles/tailwind3.css";

#container {
  margin: 0 auto;
  width: 800px;
}

.e-panel-container .content {
  vertical-align: middle;
  font-weight: 500;
  font-size: 20px;
  text-align: center;
  line-height: 45px;
}

td{
  padding: 5px;
}

div#properties {
  width: 205px;
  margin-left: 15px;
  border: 1px solid black;
  padding: 15px;
  position: absolute;
}

.inline {
  display: inline-block;
}

div#control {
  width: 500px;
}

#resize {
  margin-left: 40%;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion EJ2 React Dashboard Layout Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <link rel="stylesheet" href="App.css">
</head>
<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>  
</body>
</html>

Refer to the React Dashboard Layout feature tour page for its groundbreaking feature representations. Also explore the React Dashboard Layout example to learn how to present and manipulate data.

Add remove panels in Vue Dashboard Layout component

5 Mar 202624 minutes to read

In real-time scenarios, dashboard content often needs to be updated dynamically by adding or removing panels. This can be achieved using the addPanel and removePanel public methods.

Add or remove panels dynamically

Panels can be added dynamically using the addPanel public method by passing the panel property as parameter. Panels can be removed dynamically using the removePanel public method by passing the panel id value as a parameter.

It is also possible to remove all the panels in a Dashboard Layout by calling removeAll method.

dashboard.removeAll();

The following sample demonstrates how to add and remove panels dynamically in the Dashboard Layout. Panels can be added at any desired position and size by selecting values in the numeric inputs and clicking the add button; panels can be removed by selecting the panel ID.

<template>
    <div>
        <div className="col-lg-8 control-section" id="control_dash">
            <div className="content-wrapper">
                <div id="dashboardElement">
                    <!--  Dashboard Layout component declaration -->
                    <ejs-dashboardlayout ref="dashboard" id='dashboard_default' :columns="7">
                        <e-panels>
                            <e-panel id="Panel0" :sizeX="1" :sizeY="1" :row="0" :col="0"
                                content="<div class='content'>0</div>"></e-panel>
                            <e-panel id="Panel1" :sizeX="3" :sizeY="2" :row="0" :col="1"
                                content="<div class='content'>1</div>"></e-panel>
                            <e-panel id="Panel2" :sizeX="1" :sizeY="3" :row="0" :col="4"
                                content="<div class='content'>2</div>"></e-panel>
                            <e-panel id="Panel3" :sizeX="1" :sizeY="1" :row="1" :col="0"
                                content="<div class='content'>3</div>"></e-panel>
                            <e-panel id="Panel4" :sizeX="2" :sizeY="1" :row="2" :col="0"
                                content="<div class='content'>4</div>"></e-panel>
                            <e-panel id="Panel5" :sizeX="1" :sizeY="1" :row="2" :col="2"
                                content="<div class='content'>5</div>"></e-panel>
                            <e-panel id="Panel6" :sizeX="1" :sizeY="1" :row="2" :col="3"
                                content="<div class='content'>6</div>"></e-panel>
                        </e-panels>
                    </ejs-dashboardlayout>
                    <!-- end of Dashboard Layout component -->
                </div>
            </div>
        </div>
        <div className="col-lg-4 property-section dashboard" id="api_property">
            <div className="row property-panel-content">
                <div className="card-body">
                    <div className="form-group row">
                        <table id="add">
                            <tbody>
                                <tr>
                                    <td id="property">Add Panel properties</td>
                                </tr>
                                <tr>
                                    <td>SizeX</td>
                                    <td>
                                        <ejs-numerictextbox ref="sizex" id="sizex" placeholder="Ex: 1" :value="value" :min="min"
                                            :max="max" :floatLabelType="floatLabelType"></ejs-numerictextbox>
                                    </td>
                                </tr>
                                <tr>
                                    <td>SizeX</td>
                                    <td>
                                        <ejs-numerictextbox ref="sizey" id="sizey" placeholder="Ex: 1" :value="value" :min="min"
                                            :max="max" :floatLabelType="floatLabelType"></ejs-numerictextbox>
                                    </td>
                                </tr>
                                <tr>
                                    <td>Row</td>
                                    <td>
                                        <ejs-numerictextbox  ref="row" id="row" placeholder="Ex: 1" :value="value" :min="rowmin"
                                            :max="rowmax" :floatLabelType="floatLabelType"></ejs-numerictextbox>
                                    </td>
                                </tr>
                                <tr>
                                    <td>Column</td>
                                    <td>
                                        <ejs-numerictextbox ref="column" id="column" placeholder="Ex: 1" :value="value" :min="colmin"
                                            :max="colmax" :floatLabelType="floatLabelType"></ejs-numerictextbox>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <ejs-button id="add" class="e-primary" v-on:click="onAdd">Add
                                            Panel</ejs-button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <table id="remove">
                            <tbody>
                                <tr>
                                    <td id="property">Remove panel properties</td>
                                </tr>
                                <tr>
                                    <td> Panel Id </td>
                                    <td>
                                        <ejs-dropdownlist ref="dropdown" id='dropdown' placeholder='Select a id value'
                                            :dataSource='data'></ejs-dropdownlist>
                                    </td>
                                </tr>
                                <tr>
                                    <td> <ejs-button id="removeButton" class="e-primary" v-on:click="onRemove">Remove
                                            Panel</ejs-button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>

    // Import syncfusion Dashboard Layout component from layouts package
    import { DashboardLayoutComponent as EjsDashboardlayout, PanelDirective as EPanel, PanelsDirective as EPanels } from "@syncfusion/ej2-vue-layouts";
    // Import syncfusion button component from buttons package
    import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
    // Import syncfusion numerictextbox component from inputs package
    import { NumericTextBoxComponent as EjsNumerictextbox } from "@syncfusion/ej2-vue-inputs";
    // Import syncfusion dropdownlist component from dropdowns package
    import { DropDownListComponent as EjsDropdownlist } from "@syncfusion/ej2-vue-dropdowns";

    const floatLabelType = 'Never';
    const min = 1;
    const max = 5;
    const rowmin = 0;
    const rowmax = 5;
    const colmin = 0;
    const colmax = 4;
    const value = '';
    const data = ['Panel0', 'Panel1', 'Panel2', 'Panel3', 'Panel4', 'Panel5', 'Panel6'];
    let count = 7;

    const onAdd = () => {
        var sizeX = this.$refs.sizex.$el.ej2_instances[0];
        var sizeY = this.$refs.sizey.$el.ej2_instances[0];
        var row = this.$refs.row.$el.ej2_instances[0];
        var column = this.$refs.column.$el.ej2_instances[0];
        var dropdownObject = this.$refs.dropdown.$el.ej2_instances[0];
        var dashboardObj = this.$refs.dashboard.$el.ej2_instances[0];
        var panel = [{
            'id': "Panel" + count.toString(),
            'sizeX': sizeX.value,
            'sizeY': sizeY.value,
            'row': row.value,
            'col': column.value,
            'content': "<div class='content'>" + count + "</div>"
        }];
        dropdownObject.dataSource.push("Panel" + count.toString());
        dropdownObject.refresh();
        count = count + 1;
        dashboardObj.addPanel(panel[0]);
    }

    const onRemove = () => {
        var dropdownObject = this.$refs.dropdown.$el.ej2_instances[0];
        var dashboardObj = this.$refs.dashboard.$el.ej2_instances[0];
        dashboardObj.removePanel(dropdownObject.value);
        dropdownObject.dataSource.splice(dropdownObject.dataSource.indexOf(dropdownObject.value), 1);
        dropdownObject.value = null;
        dropdownObject.refresh();
    }

</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";

    /* Dashboard Layout component styles  */
    #dashboard_default .e-panel .e-panel-content {
        vertical-align: middle;
        font-weight: 600;
        font-size: 20px;
        text-align: center;
        line-height: 100px;
    }

    #control_dash {
        display: block;
        width: 59%;
        float: left;
    }

    #api_property {
        display: inline-block;
        margin: 10px;
    }

    #add {
        border: 1px solid black;
        padding: 10px;
        margin: 10px;
    }

    #remove {
        border: 1px solid black;
        padding: 10px;
        margin: 10px;
        width: 377px;
    }

    #property {
        padding: 10px;
    }

    #removeButton {
        border: 1px solid black;
        padding: 10px;
        margin: 10px;
        width: 125px;
    }

    #dashboardElement {
        padding-top: 30px;
    }

    #dashboard_default .e-panel {
        transition: none !important;
    }
</style>
<template>
  <div>
    <div className="col-lg-8 control-section" id="control_dash">
      <div className="content-wrapper">
        <div id="dashboardElement">
          <!--  Dashboard Layout component declaration -->
          <ejs-dashboardlayout ref="dashboard" id='dashboard_default' :columns="7">
            <e-panels>
              <e-panel id="Panel0" :sizeX="1" :sizeY="1" :row="0" :col="0"
                content="<div class='content'>0</div>"></e-panel>
              <e-panel id="Panel1" :sizeX="3" :sizeY="2" :row="0" :col="1"
                content="<div class='content'>1</div>"></e-panel>
              <e-panel id="Panel2" :sizeX="1" :sizeY="3" :row="0" :col="4"
                content="<div class='content'>2</div>"></e-panel>
              <e-panel id="Panel3" :sizeX="1" :sizeY="1" :row="1" :col="0"
                content="<div class='content'>3</div>"></e-panel>
              <e-panel id="Panel4" :sizeX="2" :sizeY="1" :row="2" :col="0"
                content="<div class='content'>4</div>"></e-panel>
              <e-panel id="Panel5" :sizeX="1" :sizeY="1" :row="2" :col="2"
                content="<div class='content'>5</div>"></e-panel>
              <e-panel id="Panel6" :sizeX="1" :sizeY="1" :row="2" :col="3"
                content="<div class='content'>6</div>"></e-panel>
            </e-panels>
          </ejs-dashboardlayout>
          <!-- end of Dashboard Layout component -->
        </div>
      </div>
    </div>
    <div className="col-lg-4 property-section dashboard" id="api_property">
      <div className="row property-panel-content">
        <div className="card-body">
          <div className="form-group row">
            <table id="add">
              <tbody>
                <tr>
                  <td id="property">Add Panel properties</td>
                </tr>
                <tr>
                  <td>SizeX</td>
                  <td>
                    <ejs-numerictextbox ref="sizex" id="sizex" placeholder="Ex: 1" :value="value" :min="min" :max="max"
                      :floatLabelType="floatLabelType"></ejs-numerictextbox>
                  </td>
                </tr>
                <tr>
                  <td>SizeX</td>
                  <td>
                    <ejs-numerictextbox ref="sizey" id="sizey" placeholder="Ex: 1" :value="value" :min="min" :max="max"
                      :floatLabelType="floatLabelType"></ejs-numerictextbox>
                  </td>
                </tr>
                <tr>
                  <td>Row</td>
                  <td>
                    <ejs-numerictextbox ref="row" id="row" placeholder="Ex: 1" :value="value" :min="rowmin" :max="rowmax"
                      :floatLabelType="floatLabelType"></ejs-numerictextbox>
                  </td>
                </tr>
                <tr>
                  <td>Column</td>
                  <td>
                    <ejs-numerictextbox ref="column" id="column" placeholder="Ex: 1" :value="value" :min="colmin" :max="colmax"
                      :floatLabelType="floatLabelType"></ejs-numerictextbox>
                  </td>
                </tr>
                <tr>
                  <td>
                    <ejs-button id="add" class="e-primary" v-on:click.native="onAdd">Add Panel</ejs-button>
                  </td>
                </tr>
              </tbody>
            </table>
            <table id="remove">
              <tbody>
                <tr>
                  <td id="property">Remove panel properties</td>
                </tr>
                <tr>
                  <td> Panel Id </td>
                  <td>
                    <ejs-dropdownlist ref="dropdown" id='dropdown' placeholder='Select a id value'
                      :dataSource='data'></ejs-dropdownlist>
                  </td>
                </tr>
                <tr>
                  <td> <ejs-button id="removeButton" class="e-primary" v-on:click.native="onRemove">Remove
                      Panel</ejs-button>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
  
<script>
  
  // Import syncfusion Dashboard Layout component from layouts package
  import { DashboardLayoutComponent, PanelDirective, PanelsDirective } from "@syncfusion/ej2-vue-layouts";
  // Import syncfusion button component from buttons package
  import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
  // Import syncfusion numerictextbox component from inputs package
  import { NumericTextBoxComponent } from "@syncfusion/ej2-vue-inputs";
  // Import syncfusion dropdownlist component from dropdowns package
  import { DropDownListComponent } from "@syncfusion/ej2-vue-dropdowns";
  
  
  export default {
    name: "App",
    components: {
      "ejs-dashboardlayout": DashboardLayoutComponent,
      "e-panels": PanelsDirective,
      "e-panel": PanelDirective,
      "ejs-numerictextbox": NumericTextBoxComponent,
      "ejs-button": ButtonComponent,
      "ejs-dropdownlist": DropDownListComponent,
  
    },
  
    data: function () {
      return {
        floatLabelType: 'Never',
        min: 1,
        max: 5,
        rowmin: 0,
        rowmax: 5,
        colmin: 0,
        colmax: 4,
        value: '',
        data: ['Panel0', 'Panel1', 'Panel2', 'Panel3', 'Panel4', 'Panel5', 'Panel6'],
        count: 7
      };
    },
    methods: {
      onAdd: function () {
        var sizeX = this.$refs.sizex.$el.ej2_instances[0];
        var sizeY = this.$refs.sizey.$el.ej2_instances[0];
        var row = this.$refs.row.$el.ej2_instances[0];
        var column = this.$refs.column.$el.ej2_instances[0];
        var dropdownObject = this.$refs.dropdown.$el.ej2_instances[0];
        var dashboardObj = this.$refs.dashboard.$el.ej2_instances[0];
        var panel = [{
          'id': "Panel" + this.count.toString(),
          'sizeX': sizeX.value,
          'sizeY': sizeY.value,
          'row': row.value,
          'col': column.value,
          'content': "<div class='content'>" + this.count + "</div>"
        }];
        dropdownObject.dataSource.push("Panel" + this.count.toString());
        dropdownObject.refresh();
        this.count = this.count + 1;
        dashboardObj.addPanel(panel[0]);
      },
  
      onRemove: function () {
        var dropdownObject = this.$refs.dropdown.$el.ej2_instances[0];
        var dashboardObj = this.$refs.dashboard.$el.ej2_instances[0];
        dashboardObj.removePanel(dropdownObject.value);
        dropdownObject.dataSource.splice(dropdownObject.dataSource.indexOf(dropdownObject.value), 1);
        dropdownObject.value = null;
        dropdownObject.refresh();
      },
    },
  }
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/material3.css";

  /* Dashboard Layout component styles  */
  #dashboard_default .e-panel .e-panel-content {
    vertical-align: middle;
    font-weight: 600;
    font-size: 20px;
    text-align: center;
    line-height: 100px;
  }

  #control_dash {
    display: block;
    width: 59%;
    float: left;
  }

  #api_property {
    display: inline-block;
    margin: 10px;
  }

  #add {
    border: 1px solid black;
    padding: 10px;
    margin: 10px;
  }

  #remove {
    border: 1px solid black;
    padding: 10px;
    margin: 10px;
    width: 377px;
  }

  #property {
    padding: 10px;
  }

  #removeButton {
    border: 1px solid black;
    padding: 10px;
    margin: 10px;
    width: 125px;
  }

  #dashboardElement {
    padding-top: 30px;
  }

  #dashboard_default .e-panel {
    transition: none !important;
  }
</style>

Refer to the Vue Dashboard Layout feature tour page for its groundbreaking feature representations. Also explore our Vue Dashboard Layout example to learn how to present and manipulate data.